<?php

// QuickTalk 1.9.0.3 build:20081001
// This is included in qtf_form_edit.php

if ( $_SESSION[QT]['m_antispam']>0 ) // this parametre can be >1
{

  if ( !isset($_SESSION[QT]['m_antispam_conf']) ) GetParam(true,'param="m_antispam_conf"');
  if ( !isset($_SESSION[QT]['m_antispam_count']) ) $_SESSION[QT]['m_antispam_count']=0;

  if ( $_SESSION[QT]['m_antispam_count']>3 ) $qtf_error = 'too many rejected messages today, retry tomorrow.';

  $strMAz     = substr($_SESSION[QT]['m_antispam_conf'],0,1);
  $strMVowel  = substr($_SESSION[QT]['m_antispam_conf'],1,1);
  $strMChars  = substr($_SESSION[QT]['m_antispam_conf'],2,1);
  $intMChars  = intval(substr($_SESSION[QT]['m_antispam_conf'],3,1));
  $strMWords  = substr($_SESSION[QT]['m_antispam_conf'],4,1);
  $intMWords  = intval(substr($_SESSION[QT]['m_antispam_conf'],5,1));
  $strMGood   = substr($_SESSION[QT]['m_antispam_conf'],6,1);
  $intMGoods  = intval(substr($_SESSION[QT]['m_antispam_conf'],7,1));
  $strMInsane = substr($_SESSION[QT]['m_antispam_conf'],8,1);
  $intMInsane = intval(substr($_SESSION[QT]['m_antispam_conf'],9,1));
  $strMRepeat = substr($_SESSION[QT]['m_antispam_conf'],10,1);
  $strMIp     = substr($_SESSION[QT]['m_antispam_conf'],11,1);

  // minimum size
  if ( empty($qtf_error) && $strMChars=='1' )
  {
    if ( strlen($oPost->text)<=$intMChars ) $qtf_error = 'message too short.';
  }

  if ( empty($qtf_error) )
  {
  $strM = strtolower(substr($oPost->text,0,500));
  }
  
  if ( empty($qtf_error) && $strMAz=='1' )
  {
    if ( !ereg("[a-z]+",$strM) ) $qtf_error = 'message suspect, no meaningful characters.';
  }

  if ( empty($qtf_error) )
  {
    $strM = strtr($strM,''  ,'eeeeeeee');
    $strM = strtr($strM,'','aaaaaaaaaa');
    $strM = strtr($strM,''  ,'iiiiiiii');
    $strM = strtr($strM,'','oooooooooo');
    $strM = strtr($strM,''  ,'uuuuuuuu'); 
  }
  
  // vowels
  if ( empty($qtf_error) && $strMVowel=='1' )
  {
    if ( !ereg("[aeiouy]+",$strM) ) $qtf_error = 'message suspect, no vowels.';
  }
  
  // check IPs
  if ( empty($qtf_error) && $strMIp=='1' )
  {
    include('avatar/qtfm_ip.inc');
    if ( array_key_exists($oDB->ip,$arrIp) ) $qtf_error = 'your ip has been locked by the administrator.';
    if ( empty($qtf_error) )
    {
    $strMIpGroup = substr($oDB->ip,0,strrpos($oDB->ip,'.')).'*';
    if ( array_key_exists($strMIpGroup,$arrIp) ) $qtf_error = 'your ip has been locked by the administrator.';
    }
  }
  
  if ( empty($qtf_error) && $strMWords=='1' )
  {
    $arrMWords = str_word_count($strM,1); // php 4.3.0
    if ( count($arrMWords)<=$intMWords ) $qtf_error = 'not enough words.';
  }

  // language
  if ( empty($qtf_error) ) {
  if ( $strMGood=='1' || $strMInsane=='1' ) {

    include(Translate('qtfm_antispam_goodbad.inc'));
    if ( $strMGood=='1' )
    {
      if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
      $interMWords = array_intersect($voc['good'],$arrMWords);
      if ( count($interMWords)<=$intMGoods ) $qtf_error = 'language not identified.';
    }
    if ( $strMInsane=='1' )
    {
      if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
      $interMWords = array_intersect($voc['bad'],$arrMWords);
      if ( count($interMWords)>=$intMInsane )
      {
        $qtf_error = 'message suspect.';
        foreach ($intMWords as $strMKey => $strMValue)
        {
        $qtf_error .= "- $strMValue";
        }
      }
    }
      
  }}

  // random keyboard
  if ( empty($qtf_error) && $strMVowel=='1' )
  {
    $iM=0;
    if ( !isset($arrMWords) ) $arrMWords = str_word_count($strM,1); // php 4.3.0
    foreach ( $arrMWords as $strMWord) {
    foreach ( array('qwe','wqe','qsd','sdf','dfg','fgh','jkl','klm','ghg','fjf','jfj','fgf','dfd','fdj','dfj') as $aM ) {
      if ( strpos($strMWord,$aM)===false ) continue;
      $iM++;
    }}  
    if ( $iM>1 ) $qtf_error = 'message suspect.';
  }

  // END ANTISPAM

  // no error means: consecutive error reset to 0
  if ( empty($qtf_error) ) $_SESSION[QT]['m_antispam_count']=0;

  // watch for consecutive errors
  if ( !empty($qtf_error) ) {
  if ( $strMRepeat=='1' ) {
    $_SESSION[QT]['m_antispam_count']++;
    if ( $_SESSION[QT]['m_antispam_count']>3 )
    {
      // ban user 1 day
      if ( $oVIP->id!=1 ) $oDB->Query('UPDATE '.TABUSER.' SET closed="1" WHERE id='.$oVIP->id);
      $qtf_error = 'too many rejected messages today, retry tomorrow.';
    }
  }
  }
  
  if ( !empty($qtf_error) )
  {
  include(Translate('qtfm_antispam.inc'));
  $qtf_error = $L['E_text'].'<br/>'.$L['antispam']['Says'].'<br/>'.$qtf_error.'<br/>';
  }

  // bypass if admin
  if ( !empty($qtf_error) && $oVIP->role=='A' )
  {
    $qtf_warning = $qtf_error;
    $qtf_error='';
  }

}

?>